"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from zav.chat_service.api_client import ApiClient, Endpoint as _Endpoint
from zav.chat_service.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from zav.chat_service.model.generate_recommendations_form import GenerateRecommendationsForm
from zav.chat_service.model.http_validation_error import HTTPValidationError


class RecommendationsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.generate_recommendations_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/recommendations',
                'operation_id': 'generate_recommendations',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'tenant',
                    'generate_recommendations_form',
                    'index_id',
                    'requester_uuid',
                    'user_roles',
                    'user_tenants',
                    'authorization',
                    'x_auth',
                ],
                'required': [
                    'tenant',
                    'generate_recommendations_form',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'tenant':
                        (str,),
                    'generate_recommendations_form':
                        (GenerateRecommendationsForm,),
                    'index_id':
                        (str,),
                    'requester_uuid':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'authorization':
                        (str,),
                    'x_auth':
                        (str,),
                },
                'attribute_map': {
                    'tenant': 'tenant',
                    'index_id': 'index_id',
                    'requester_uuid': 'requester-uuid',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'authorization': 'Authorization',
                    'x_auth': 'X-Auth',
                },
                'location_map': {
                    'tenant': 'query',
                    'generate_recommendations_form': 'body',
                    'index_id': 'query',
                    'requester_uuid': 'header',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'authorization': 'header',
                    'x_auth': 'header',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def generate_recommendations(
        self,
        tenant,
        generate_recommendations_form,
        **kwargs
    ):
        """Generate Recommendations  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.generate_recommendations(tenant, generate_recommendations_form, async_req=True)
        >>> result = thread.get()

        Args:
            tenant (str):
            generate_recommendations_form (GenerateRecommendationsForm):

        Keyword Args:
            index_id (str): [optional]
            requester_uuid (str): [optional]
            user_roles (str): [optional]
            user_tenants (str): [optional]
            authorization (str): [optional]
            x_auth (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['tenant'] = \
            tenant
        kwargs['generate_recommendations_form'] = \
            generate_recommendations_form
        return self.generate_recommendations_endpoint.call_with_http_info(**kwargs)

